com.fasterxml.jackson.dataformat.avro

## Class AvroAnnotationIntrospector

- java.lang.Object
- - com.fasterxml.jackson.databind.AnnotationIntrospector
  - - com.fasterxml.jackson.dataformat.avro.AvroAnnotationIntrospector

- All Implemented Interfaces:
    com.fasterxml.jackson.core.Versioned, Serializable

      public class AvroAnnotationIntrospector
      extends com.fasterxml.jackson.databind.AnnotationIntrospector

  Adds support for the following annotations from the Apache Avro implementation:
  - `@AvroIgnore` - Alias for `JsonIgnore`
  - `@AvroName("custom Name")` - Alias for `JsonProperty("custom name")`
  - `@AvroDefault("default value")` - Alias for `JsonProperty.defaultValue`, to define default value for generated Schemas
  - `@Nullable` - Alias for `JsonProperty(required = false)`
  - `@Stringable` - Alias for `JsonCreator` on the constructor and `JsonValue` on the `Object.toString()` method.
  - `@Union` - Alias for `JsonSubTypes`
  Since:
    2.9
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.AnnotationIntrospector

      `com.fasterxml.jackson.databind.AnnotationIntrospector.ReferenceProperty`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AvroAnnotationIntrospector()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected com.fasterxml.jackson.databind.PropertyName` | `_findName(com.fasterxml.jackson.databind.introspect.Annotated a)`
    `protected com.fasterxml.jackson.databind.jsontype.TypeResolverBuilder<?>` | `_findTypeResolver(com.fasterxml.jackson.databind.cfg.MapperConfig<?> config, com.fasterxml.jackson.databind.introspect.Annotated ann, com.fasterxml.jackson.databind.JavaType baseType)`
    `protected Class<?>[]` | `_getUnionTypes(com.fasterxml.jackson.databind.introspect.Annotated a)`
    `com.fasterxml.jackson.annotation.JsonCreator.Mode` | `findCreatorAnnotation(com.fasterxml.jackson.databind.cfg.MapperConfig<?> config, com.fasterxml.jackson.databind.introspect.Annotated a)`
    `Object` | `findDeserializer(com.fasterxml.jackson.databind.introspect.Annotated am)`
    `com.fasterxml.jackson.databind.PropertyName` | `findNameForDeserialization(com.fasterxml.jackson.databind.introspect.Annotated a)`
    `com.fasterxml.jackson.databind.PropertyName` | `findNameForSerialization(com.fasterxml.jackson.databind.introspect.Annotated a)`
    `List<com.fasterxml.jackson.databind.PropertyName>` | `findPropertyAliases(com.fasterxml.jackson.databind.introspect.Annotated m)`
    `com.fasterxml.jackson.databind.jsontype.TypeResolverBuilder<?>` | `findPropertyContentTypeResolver(com.fasterxml.jackson.databind.cfg.MapperConfig<?> config, com.fasterxml.jackson.databind.introspect.AnnotatedMember am, com.fasterxml.jackson.databind.JavaType containerType)`
    `String` | `findPropertyDefaultValue(com.fasterxml.jackson.databind.introspect.Annotated m)`
    `com.fasterxml.jackson.databind.jsontype.TypeResolverBuilder<?>` | `findPropertyTypeResolver(com.fasterxml.jackson.databind.cfg.MapperConfig<?> config, com.fasterxml.jackson.databind.introspect.AnnotatedMember am, com.fasterxml.jackson.databind.JavaType baseType)`
    `Object` | `findSerializer(com.fasterxml.jackson.databind.introspect.Annotated a)`
    `List<com.fasterxml.jackson.databind.jsontype.NamedType>` | `findSubtypes(com.fasterxml.jackson.databind.introspect.Annotated a)`
    `com.fasterxml.jackson.databind.jsontype.TypeResolverBuilder<?>` | `findTypeResolver(com.fasterxml.jackson.databind.cfg.MapperConfig<?> config, com.fasterxml.jackson.databind.introspect.AnnotatedClass ac, com.fasterxml.jackson.databind.JavaType baseType)`
    `boolean` | `hasIgnoreMarker(com.fasterxml.jackson.databind.introspect.AnnotatedMember m)`
    `Boolean` | `hasRequiredMarker(com.fasterxml.jackson.databind.introspect.AnnotatedMember m)`
    `com.fasterxml.jackson.core.Version` | `version()`

    - ### Methods inherited from class com.fasterxml.jackson.databind.AnnotationIntrospector

      `_findAnnotation, _hasAnnotation, _hasOneOf, allIntrospectors, allIntrospectors, findAndAddVirtualProperties, findAutoDetectVisibility, findClassDescription, findContentDeserializer, findContentSerializer, findCreatorBinding, findDefaultEnumValue, findDeserializationContentConverter, findDeserializationContentType, findDeserializationConverter, findDeserializationKeyType, findDeserializationType, findEnumValue, findEnumValues, findFilterId, findFormat, findIgnoreUnknownProperties, findImplicitPropertyName, findInjectableValue, findInjectableValueId, findKeyDeserializer, findKeySerializer, findMergeInfo, findNamingStrategy, findNullSerializer, findObjectIdInfo, findObjectReferenceInfo, findPOJOBuilder, findPOJOBuilderConfig, findPropertiesToIgnore, findPropertiesToIgnore, findPropertyAccess, findPropertyDescription, findPropertyIgnorals, findPropertyInclusion, findPropertyIndex, findReferenceType, findRootName, findSerializationContentConverter, findSerializationContentType, findSerializationConverter, findSerializationInclusion, findSerializationInclusionForContent, findSerializationKeyType, findSerializationPropertyOrder, findSerializationSortAlphabetically, findSerializationType, findSerializationTyping, findSetterInfo, findTypeName, findUnwrappingNameTransformer, findValueInstantiator, findViews, findWrapperName, hasAnyGetter, hasAnyGetterAnnotation, hasAnySetter, hasAnySetterAnnotation, hasAsValue, hasAsValueAnnotation, hasCreatorAnnotation, isAnnotationBundle, isIgnorableType, isTypeId, nopInstance, pair, refineDeserializationType, refineSerializationType, resolveSetterConflict`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AvroAnnotationIntrospector

          public AvroAnnotationIntrospector()

  - ### Method Detail

    - #### version

          public com.fasterxml.jackson.core.Version version()

      Specified by:
        `version` in interface `com.fasterxml.jackson.core.Versioned`
      Specified by:
        `version` in class `com.fasterxml.jackson.databind.AnnotationIntrospector`

    - #### hasIgnoreMarker

          public boolean hasIgnoreMarker(com.fasterxml.jackson.databind.introspect.AnnotatedMember m)

      Overrides:
        `hasIgnoreMarker` in class `com.fasterxml.jackson.databind.AnnotationIntrospector`

    - #### findNameForSerialization

          public com.fasterxml.jackson.databind.PropertyName findNameForSerialization(com.fasterxml.jackson.databind.introspect.Annotated a)

      Overrides:
        `findNameForSerialization` in class `com.fasterxml.jackson.databind.AnnotationIntrospector`

    - #### findNameForDeserialization

          public com.fasterxml.jackson.databind.PropertyName findNameForDeserialization(com.fasterxml.jackson.databind.introspect.Annotated a)

      Overrides:
        `findNameForDeserialization` in class `com.fasterxml.jackson.databind.AnnotationIntrospector`

    - #### findDeserializer

          public Object findDeserializer(com.fasterxml.jackson.databind.introspect.Annotated am)

      Overrides:
        `findDeserializer` in class `com.fasterxml.jackson.databind.AnnotationIntrospector`

    - #### findPropertyDefaultValue

          public String findPropertyDefaultValue(com.fasterxml.jackson.databind.introspect.Annotated m)

      Overrides:
        `findPropertyDefaultValue` in class `com.fasterxml.jackson.databind.AnnotationIntrospector`

    - #### findPropertyAliases

          public List<com.fasterxml.jackson.databind.PropertyName> findPropertyAliases(com.fasterxml.jackson.databind.introspect.Annotated m)

      Overrides:
        `findPropertyAliases` in class `com.fasterxml.jackson.databind.AnnotationIntrospector`

    - #### _findName

          protected com.fasterxml.jackson.databind.PropertyName _findName(com.fasterxml.jackson.databind.introspect.Annotated a)

    - #### hasRequiredMarker

          public Boolean hasRequiredMarker(com.fasterxml.jackson.databind.introspect.AnnotatedMember m)

      Overrides:
        `hasRequiredMarker` in class `com.fasterxml.jackson.databind.AnnotationIntrospector`

    - #### findCreatorAnnotation

          public com.fasterxml.jackson.annotation.JsonCreator.Mode findCreatorAnnotation(com.fasterxml.jackson.databind.cfg.MapperConfig<?> config,
                                                                                         com.fasterxml.jackson.databind.introspect.Annotated a)

      Overrides:
        `findCreatorAnnotation` in class `com.fasterxml.jackson.databind.AnnotationIntrospector`

    - #### findSerializer

          public Object findSerializer(com.fasterxml.jackson.databind.introspect.Annotated a)

      Overrides:
        `findSerializer` in class `com.fasterxml.jackson.databind.AnnotationIntrospector`

    - #### findSubtypes

          public List<com.fasterxml.jackson.databind.jsontype.NamedType> findSubtypes(com.fasterxml.jackson.databind.introspect.Annotated a)

      Overrides:
        `findSubtypes` in class `com.fasterxml.jackson.databind.AnnotationIntrospector`

    - #### findTypeResolver

          public com.fasterxml.jackson.databind.jsontype.TypeResolverBuilder<?> findTypeResolver(com.fasterxml.jackson.databind.cfg.MapperConfig<?> config,
                                                                                                 com.fasterxml.jackson.databind.introspect.AnnotatedClass ac,
                                                                                                 com.fasterxml.jackson.databind.JavaType baseType)

      Overrides:
        `findTypeResolver` in class `com.fasterxml.jackson.databind.AnnotationIntrospector`

    - #### findPropertyTypeResolver

          public com.fasterxml.jackson.databind.jsontype.TypeResolverBuilder<?> findPropertyTypeResolver(com.fasterxml.jackson.databind.cfg.MapperConfig<?> config,
                                                                                                         com.fasterxml.jackson.databind.introspect.AnnotatedMember am,
                                                                                                         com.fasterxml.jackson.databind.JavaType baseType)

      Overrides:
        `findPropertyTypeResolver` in class `com.fasterxml.jackson.databind.AnnotationIntrospector`

    - #### findPropertyContentTypeResolver

          public com.fasterxml.jackson.databind.jsontype.TypeResolverBuilder<?> findPropertyContentTypeResolver(com.fasterxml.jackson.databind.cfg.MapperConfig<?> config,
                                                                                                                com.fasterxml.jackson.databind.introspect.AnnotatedMember am,
                                                                                                                com.fasterxml.jackson.databind.JavaType containerType)

      Overrides:
        `findPropertyContentTypeResolver` in class `com.fasterxml.jackson.databind.AnnotationIntrospector`

    - #### _findTypeResolver

          protected com.fasterxml.jackson.databind.jsontype.TypeResolverBuilder<?> _findTypeResolver(com.fasterxml.jackson.databind.cfg.MapperConfig<?> config,
                                                                                                     com.fasterxml.jackson.databind.introspect.Annotated ann,
                                                                                                     com.fasterxml.jackson.databind.JavaType baseType)

    - #### _getUnionTypes

          protected Class<?>[] _getUnionTypes(com.fasterxml.jackson.databind.introspect.Annotated a)

Copyright © 2019 FasterXML. All rights reserved.